import { __module as v } from "../../../_virtual/mode-javascript.ts";
(function(k, b) {
  ace.define("ace/mode/jsdoc_comment_highlight_rules", ["require", "exports", "module", "ace/lib/oop", "ace/mode/text_highlight_rules"], function(u, x, h) {
    var m = u("../lib/oop"), p = u("./text_highlight_rules").TextHighlightRules, d = function() {
      this.$rules = {
        start: [
          {
            token: ["comment.doc.tag", "comment.doc.text", "lparen.doc"],
            regex: "(@(?:param|member|typedef|property|namespace|var|const|callback))(\\s*)({)",
            push: [
              {
                token: "lparen.doc",
                regex: "{",
                push: [
                  {
                    include: "doc-syntax"
                  },
                  {
                    token: "rparen.doc",
                    regex: "}|(?=$)",
                    next: "pop"
                  }
                ]
              },
              {
                token: ["rparen.doc", "text.doc", "variable.parameter.doc", "lparen.doc", "variable.parameter.doc", "rparen.doc"],
                regex: /(})(\s*)(?:([\w=:\/\.]+)|(?:(\[)([\w=:\/\.]+)(\])))/,
                next: "pop"
              },
              {
                token: "rparen.doc",
                regex: "}|(?=$)",
                next: "pop"
              },
              {
                include: "doc-syntax"
              },
              {
                defaultToken: "text.doc"
              }
            ]
          },
          {
            token: ["comment.doc.tag", "text.doc", "lparen.doc"],
            regex: "(@(?:returns?|yields|type|this|suppress|public|protected|private|package|modifies|implements|external|exception|throws|enum|define|extends))(\\s*)({)",
            push: [
              {
                token: "lparen.doc",
                regex: "{",
                push: [
                  {
                    include: "doc-syntax"
                  },
                  {
                    token: "rparen.doc",
                    regex: "}|(?=$)",
                    next: "pop"
                  }
                ]
              },
              {
                token: "rparen.doc",
                regex: "}|(?=$)",
                next: "pop"
              },
              {
                include: "doc-syntax"
              },
              {
                defaultToken: "text.doc"
              }
            ]
          },
          {
            token: ["comment.doc.tag", "text.doc", "variable.parameter.doc"],
            regex: '(@(?:alias|memberof|instance|module|name|lends|namespace|external|this|template|requires|param|implements|function|extends|typedef|mixes|constructor|var|memberof\\!|event|listens|exports|class|constructs|interface|emits|fires|throws|const|callback|borrows|augments))(\\s+)(\\w[\\w#.:/~"\\-]*)?'
          },
          {
            token: ["comment.doc.tag", "text.doc", "variable.parameter.doc"],
            regex: "(@method)(\\s+)(\\w[\\w.\\(\\)]*)"
          },
          {
            token: "comment.doc.tag",
            regex: "@access\\s+(?:private|public|protected)"
          },
          {
            token: "comment.doc.tag",
            regex: "@kind\\s+(?:class|constant|event|external|file|function|member|mixin|module|namespace|typedef)"
          },
          {
            token: "comment.doc.tag",
            regex: "@\\w+(?=\\s|$)"
          },
          d.getTagRule(),
          {
            defaultToken: "comment.doc",
            caseInsensitive: !0
          }
        ],
        "doc-syntax": [{
          token: "operator.doc",
          regex: /[|:]/
        }, {
          token: "paren.doc",
          regex: /[\[\]]/
        }]
      }, this.normalizeRules();
    };
    m.inherits(d, p), d.getTagRule = function(e) {
      return {
        token: "comment.doc.tag.storage.type",
        regex: "\\b(?:TODO|FIXME|XXX|HACK)\\b"
      };
    }, d.getStartRule = function(e) {
      return {
        token: "comment.doc",
        // doc comment
        regex: "\\/\\*(?=\\*)",
        next: e
      };
    }, d.getEndRule = function(e) {
      return {
        token: "comment.doc",
        // closing comment
        regex: "\\*\\/",
        next: e
      };
    }, x.JsDocCommentHighlightRules = d;
  }), ace.define("ace/mode/javascript_highlight_rules", ["require", "exports", "module", "ace/lib/oop", "ace/mode/jsdoc_comment_highlight_rules", "ace/mode/text_highlight_rules"], function(u, x, h) {
    var m = u("../lib/oop"), p = u("./jsdoc_comment_highlight_rules").JsDocCommentHighlightRules, d = u("./text_highlight_rules").TextHighlightRules, e = "[a-zA-Z\\$_¡-￿][a-zA-Z\\d\\$_¡-￿]*", r = function(a) {
      var n = this.createKeywordMapper({
        "variable.language": "Array|Boolean|Date|Function|Iterator|Number|Object|RegExp|String|Proxy|Symbol|Namespace|QName|XML|XMLList|ArrayBuffer|Float32Array|Float64Array|Int16Array|Int32Array|Int8Array|Uint16Array|Uint32Array|Uint8Array|Uint8ClampedArray|Error|EvalError|InternalError|RangeError|ReferenceError|StopIteration|SyntaxError|TypeError|URIError|decodeURI|decodeURIComponent|encodeURI|encodeURIComponent|eval|isFinite|isNaN|parseFloat|parseInt|JSON|Math|this|arguments|prototype|window|document",
        // Pseudo
        keyword: "const|yield|import|get|set|async|await|break|case|catch|continue|default|delete|do|else|finally|for|function|if|in|of|instanceof|new|return|switch|throw|try|typeof|let|var|while|with|debugger|__parent__|__count__|escape|unescape|with|__proto__|class|enum|extends|super|export|implements|private|public|interface|package|protected|static|constructor",
        "storage.type": "const|let|var|function",
        "constant.language": "null|Infinity|NaN|undefined",
        "support.function": "alert",
        "constant.language.boolean": "true|false"
      }, "identifier"), s = "case|do|else|finally|in|instanceof|return|throw|try|typeof|yield|void", i = "\\\\(?:x[0-9a-fA-F]{2}|u[0-9a-fA-F]{4}|u{[0-9a-fA-F]{1,6}}|[0-2][0-7]{0,2}|3[0-7][0-7]?|[4-7][0-7]?|.)";
      this.$rules = {
        no_regex: [
          p.getStartRule("doc-start"),
          o("no_regex"),
          {
            token: "string",
            regex: "'(?=.)",
            next: "qstring"
          },
          {
            token: "string",
            regex: '"(?=.)',
            next: "qqstring"
          },
          {
            token: "constant.numeric",
            // hexadecimal, octal and binary
            regex: /0(?:[xX][0-9a-fA-F]+|[oO][0-7]+|[bB][01]+)\b/
          },
          {
            token: "constant.numeric",
            // decimal integers and floats
            regex: /(?:\d\d*(?:\.\d*)?|\.\d+)(?:[eE][+-]?\d+\b)?/
          },
          {
            token: [
              "storage.type",
              "punctuation.operator",
              "support.function",
              "punctuation.operator",
              "entity.name.function",
              "text",
              "keyword.operator"
            ],
            regex: "(" + e + ")(\\.)(prototype)(\\.)(" + e + ")(\\s*)(=)",
            next: "function_arguments"
          },
          {
            token: [
              "storage.type",
              "punctuation.operator",
              "entity.name.function",
              "text",
              "keyword.operator",
              "text",
              "storage.type",
              "text",
              "paren.lparen"
            ],
            regex: "(" + e + ")(\\.)(" + e + ")(\\s*)(=)(\\s*)(function\\*?)(\\s*)(\\()",
            next: "function_arguments"
          },
          {
            token: [
              "entity.name.function",
              "text",
              "keyword.operator",
              "text",
              "storage.type",
              "text",
              "paren.lparen"
            ],
            regex: "(" + e + ")(\\s*)(=)(\\s*)(function\\*?)(\\s*)(\\()",
            next: "function_arguments"
          },
          {
            token: [
              "storage.type",
              "punctuation.operator",
              "entity.name.function",
              "text",
              "keyword.operator",
              "text",
              "storage.type",
              "text",
              "entity.name.function",
              "text",
              "paren.lparen"
            ],
            regex: "(" + e + ")(\\.)(" + e + ")(\\s*)(=)(\\s*)(function\\*?)(\\s+)(\\w+)(\\s*)(\\()",
            next: "function_arguments"
          },
          {
            token: [
              "storage.type",
              "text",
              "entity.name.function",
              "text",
              "paren.lparen"
            ],
            regex: "(function\\*?)(\\s+)(" + e + ")(\\s*)(\\()",
            next: "function_arguments"
          },
          {
            token: [
              "entity.name.function",
              "text",
              "punctuation.operator",
              "text",
              "storage.type",
              "text",
              "paren.lparen"
            ],
            regex: "(" + e + ")(\\s*)(:)(\\s*)(function\\*?)(\\s*)(\\()",
            next: "function_arguments"
          },
          {
            token: [
              "text",
              "text",
              "storage.type",
              "text",
              "paren.lparen"
            ],
            regex: "(:)(\\s*)(function\\*?)(\\s*)(\\()",
            next: "function_arguments"
          },
          {
            token: "keyword",
            regex: `from(?=\\s*('|"))`
          },
          {
            token: "keyword",
            regex: "(?:" + s + ")\\b",
            next: "start"
          },
          {
            token: "support.constant",
            regex: /that\b/
          },
          {
            token: ["storage.type", "punctuation.operator", "support.function.firebug"],
            regex: /(console)(\.)(warn|info|log|error|debug|time|trace|timeEnd|assert)\b/
          },
          {
            token: n,
            regex: e
          },
          {
            token: "punctuation.operator",
            regex: /[.](?![.])/,
            next: "property"
          },
          {
            token: "storage.type",
            regex: /=>/,
            next: "start"
          },
          {
            token: "keyword.operator",
            regex: /--|\+\+|\.{3}|===|==|=|!=|!==|<+=?|>+=?|!|&&|\|\||\?:|[!$%&*+\-~\/^]=?/,
            next: "start"
          },
          {
            token: "punctuation.operator",
            regex: /[?:,;.]/,
            next: "start"
          },
          {
            token: "paren.lparen",
            regex: /[\[({]/,
            next: "start"
          },
          {
            token: "paren.rparen",
            regex: /[\])}]/
          },
          {
            token: "comment",
            regex: /^#!.*$/
          }
        ],
        property: [
          {
            token: "text",
            regex: "\\s+"
          },
          {
            token: [
              "storage.type",
              "punctuation.operator",
              "entity.name.function",
              "text",
              "keyword.operator",
              "text",
              "storage.type",
              "text",
              "entity.name.function",
              "text",
              "paren.lparen"
            ],
            regex: "(" + e + ")(\\.)(" + e + ")(\\s*)(=)(\\s*)(function\\*?)(?:(\\s+)(\\w+))?(\\s*)(\\()",
            next: "function_arguments"
          },
          {
            token: "punctuation.operator",
            regex: /[.](?![.])/
          },
          {
            token: "support.function",
            regex: /(s(?:h(?:ift|ow(?:Mod(?:elessDialog|alDialog)|Help))|croll(?:X|By(?:Pages|Lines)?|Y|To)?|t(?:op|rike)|i(?:n|zeToContent|debar|gnText)|ort|u(?:p|b(?:str(?:ing)?)?)|pli(?:ce|t)|e(?:nd|t(?:Re(?:sizable|questHeader)|M(?:i(?:nutes|lliseconds)|onth)|Seconds|Ho(?:tKeys|urs)|Year|Cursor|Time(?:out)?|Interval|ZOptions|Date|UTC(?:M(?:i(?:nutes|lliseconds)|onth)|Seconds|Hours|Date|FullYear)|FullYear|Active)|arch)|qrt|lice|avePreferences|mall)|h(?:ome|andleEvent)|navigate|c(?:har(?:CodeAt|At)|o(?:s|n(?:cat|textual|firm)|mpile)|eil|lear(?:Timeout|Interval)?|a(?:ptureEvents|ll)|reate(?:StyleSheet|Popup|EventObject))|t(?:o(?:GMTString|S(?:tring|ource)|U(?:TCString|pperCase)|Lo(?:caleString|werCase))|est|a(?:n|int(?:Enabled)?))|i(?:s(?:NaN|Finite)|ndexOf|talics)|d(?:isableExternalCapture|ump|etachEvent)|u(?:n(?:shift|taint|escape|watch)|pdateCommands)|j(?:oin|avaEnabled)|p(?:o(?:p|w)|ush|lugins.refresh|a(?:ddings|rse(?:Int|Float)?)|r(?:int|ompt|eference))|e(?:scape|nableExternalCapture|val|lementFromPoint|x(?:p|ec(?:Script|Command)?))|valueOf|UTC|queryCommand(?:State|Indeterm|Enabled|Value)|f(?:i(?:nd|lter|le(?:ModifiedDate|Size|CreatedDate|UpdatedDate)|xed)|o(?:nt(?:size|color)|rward|rEach)|loor|romCharCode)|watch|l(?:ink|o(?:ad|g)|astIndexOf)|a(?:sin|nchor|cos|t(?:tachEvent|ob|an(?:2)?)|pply|lert|b(?:s|ort))|r(?:ou(?:nd|teEvents)|e(?:size(?:By|To)|calc|turnValue|place|verse|l(?:oad|ease(?:Capture|Events)))|andom)|g(?:o|et(?:ResponseHeader|M(?:i(?:nutes|lliseconds)|onth)|Se(?:conds|lection)|Hours|Year|Time(?:zoneOffset)?|Da(?:y|te)|UTC(?:M(?:i(?:nutes|lliseconds)|onth)|Seconds|Hours|Da(?:y|te)|FullYear)|FullYear|A(?:ttention|llResponseHeaders)))|m(?:in|ove(?:B(?:y|elow)|To(?:Absolute)?|Above)|ergeAttributes|a(?:tch|rgins|x))|b(?:toa|ig|o(?:ld|rderWidths)|link|ack))\b(?=\()/
          },
          {
            token: "support.function.dom",
            regex: /(s(?:ub(?:stringData|mit)|plitText|e(?:t(?:NamedItem|Attribute(?:Node)?)|lect))|has(?:ChildNodes|Feature)|namedItem|c(?:l(?:ick|o(?:se|neNode))|reate(?:C(?:omment|DATASection|aption)|T(?:Head|extNode|Foot)|DocumentFragment|ProcessingInstruction|E(?:ntityReference|lement)|Attribute))|tabIndex|i(?:nsert(?:Row|Before|Cell|Data)|tem)|open|delete(?:Row|C(?:ell|aption)|T(?:Head|Foot)|Data)|focus|write(?:ln)?|a(?:dd|ppend(?:Child|Data))|re(?:set|place(?:Child|Data)|move(?:NamedItem|Child|Attribute(?:Node)?)?)|get(?:NamedItem|Element(?:sBy(?:Name|TagName|ClassName)|ById)|Attribute(?:Node)?)|blur)\b(?=\()/
          },
          {
            token: "support.constant",
            regex: /(s(?:ystemLanguage|cr(?:ipts|ollbars|een(?:X|Y|Top|Left))|t(?:yle(?:Sheets)?|atus(?:Text|bar)?)|ibling(?:Below|Above)|ource|uffixes|e(?:curity(?:Policy)?|l(?:ection|f)))|h(?:istory|ost(?:name)?|as(?:h|Focus))|y|X(?:MLDocument|SLDocument)|n(?:ext|ame(?:space(?:s|URI)|Prop))|M(?:IN_VALUE|AX_VALUE)|c(?:haracterSet|o(?:n(?:structor|trollers)|okieEnabled|lorDepth|mp(?:onents|lete))|urrent|puClass|l(?:i(?:p(?:boardData)?|entInformation)|osed|asses)|alle(?:e|r)|rypto)|t(?:o(?:olbar|p)|ext(?:Transform|Indent|Decoration|Align)|ags)|SQRT(?:1_2|2)|i(?:n(?:ner(?:Height|Width)|put)|ds|gnoreCase)|zIndex|o(?:scpu|n(?:readystatechange|Line)|uter(?:Height|Width)|p(?:sProfile|ener)|ffscreenBuffering)|NEGATIVE_INFINITY|d(?:i(?:splay|alog(?:Height|Top|Width|Left|Arguments)|rectories)|e(?:scription|fault(?:Status|Ch(?:ecked|arset)|View)))|u(?:ser(?:Profile|Language|Agent)|n(?:iqueID|defined)|pdateInterval)|_content|p(?:ixelDepth|ort|ersonalbar|kcs11|l(?:ugins|atform)|a(?:thname|dding(?:Right|Bottom|Top|Left)|rent(?:Window|Layer)?|ge(?:X(?:Offset)?|Y(?:Offset)?))|r(?:o(?:to(?:col|type)|duct(?:Sub)?|mpter)|e(?:vious|fix)))|e(?:n(?:coding|abledPlugin)|x(?:ternal|pando)|mbeds)|v(?:isibility|endor(?:Sub)?|Linkcolor)|URLUnencoded|P(?:I|OSITIVE_INFINITY)|f(?:ilename|o(?:nt(?:Size|Family|Weight)|rmName)|rame(?:s|Element)|gColor)|E|whiteSpace|l(?:i(?:stStyleType|n(?:eHeight|kColor))|o(?:ca(?:tion(?:bar)?|lName)|wsrc)|e(?:ngth|ft(?:Context)?)|a(?:st(?:M(?:odified|atch)|Index|Paren)|yer(?:s|X)|nguage))|a(?:pp(?:MinorVersion|Name|Co(?:deName|re)|Version)|vail(?:Height|Top|Width|Left)|ll|r(?:ity|guments)|Linkcolor|bove)|r(?:ight(?:Context)?|e(?:sponse(?:XML|Text)|adyState))|global|x|m(?:imeTypes|ultiline|enubar|argin(?:Right|Bottom|Top|Left))|L(?:N(?:10|2)|OG(?:10E|2E))|b(?:o(?:ttom|rder(?:Width|RightWidth|BottomWidth|Style|Color|TopWidth|LeftWidth))|ufferDepth|elow|ackground(?:Color|Image)))\b/
          },
          {
            token: "identifier",
            regex: e
          },
          {
            regex: "",
            token: "empty",
            next: "no_regex"
          }
        ],
        start: [
          p.getStartRule("doc-start"),
          o("start"),
          {
            token: "string.regexp",
            regex: "\\/",
            next: "regex"
          },
          {
            token: "text",
            regex: "\\s+|^$",
            next: "start"
          },
          {
            token: "empty",
            regex: "",
            next: "no_regex"
          }
        ],
        regex: [
          {
            token: "regexp.keyword.operator",
            regex: "\\\\(?:u[\\da-fA-F]{4}|x[\\da-fA-F]{2}|.)"
          },
          {
            token: "string.regexp",
            regex: "/[sxngimy]*",
            next: "no_regex"
          },
          {
            token: "invalid",
            regex: /\{\d+\b,?\d*\}[+*]|[+*$^?][+*]|[$^][?]|\?{3,}/
          },
          {
            token: "constant.language.escape",
            regex: /\(\?[:=!]|\)|\{\d+\b,?\d*\}|[+*]\?|[()$^+*?.]/
          },
          {
            token: "constant.language.delimiter",
            regex: /\|/
          },
          {
            token: "constant.language.escape",
            regex: /\[\^?/,
            next: "regex_character_class"
          },
          {
            token: "empty",
            regex: "$",
            next: "no_regex"
          },
          {
            defaultToken: "string.regexp"
          }
        ],
        regex_character_class: [
          {
            token: "regexp.charclass.keyword.operator",
            regex: "\\\\(?:u[\\da-fA-F]{4}|x[\\da-fA-F]{2}|.)"
          },
          {
            token: "constant.language.escape",
            regex: "]",
            next: "regex"
          },
          {
            token: "constant.language.escape",
            regex: "-"
          },
          {
            token: "empty",
            regex: "$",
            next: "no_regex"
          },
          {
            defaultToken: "string.regexp.charachterclass"
          }
        ],
        default_parameter: [
          {
            token: "string",
            regex: "'(?=.)",
            push: [
              {
                token: "string",
                regex: "'|$",
                next: "pop"
              },
              {
                include: "qstring"
              }
            ]
          },
          {
            token: "string",
            regex: '"(?=.)',
            push: [
              {
                token: "string",
                regex: '"|$',
                next: "pop"
              },
              {
                include: "qqstring"
              }
            ]
          },
          {
            token: "constant.language",
            regex: "null|Infinity|NaN|undefined"
          },
          {
            token: "constant.numeric",
            // hexadecimal, octal and binary
            regex: /0(?:[xX][0-9a-fA-F]+|[oO][0-7]+|[bB][01]+)\b/
          },
          {
            token: "constant.numeric",
            // decimal integers and floats
            regex: /(?:\d\d*(?:\.\d*)?|\.\d+)(?:[eE][+-]?\d+\b)?/
          },
          {
            token: "punctuation.operator",
            regex: ",",
            next: "function_arguments"
          },
          {
            token: "text",
            regex: "\\s+"
          },
          {
            token: "punctuation.operator",
            regex: "$"
          },
          {
            token: "empty",
            regex: "",
            next: "no_regex"
          }
        ],
        function_arguments: [
          o("function_arguments"),
          {
            token: "variable.parameter",
            regex: e
          },
          {
            token: "punctuation.operator",
            regex: ","
          },
          {
            token: "text",
            regex: "\\s+"
          },
          {
            token: "punctuation.operator",
            regex: "$"
          },
          {
            token: "empty",
            regex: "",
            next: "no_regex"
          }
        ],
        qqstring: [
          {
            token: "constant.language.escape",
            regex: i
          },
          {
            token: "string",
            regex: "\\\\$",
            consumeLineEnd: !0
          },
          {
            token: "string",
            regex: '"|$',
            next: "no_regex"
          },
          {
            defaultToken: "string"
          }
        ],
        qstring: [
          {
            token: "constant.language.escape",
            regex: i
          },
          {
            token: "string",
            regex: "\\\\$",
            consumeLineEnd: !0
          },
          {
            token: "string",
            regex: "'|$",
            next: "no_regex"
          },
          {
            defaultToken: "string"
          }
        ]
      }, (!a || !a.noES6) && (this.$rules.no_regex.unshift({
        regex: "[{}]",
        onMatch: function(t, c, g) {
          if (this.next = t == "{" ? this.nextState : "", t == "{" && g.length)
            g.unshift("start", c);
          else if (t == "}" && g.length && (g.shift(), this.next = g.shift(), this.next.indexOf("string") != -1 || this.next.indexOf("jsx") != -1))
            return "paren.quasi.end";
          return t == "{" ? "paren.lparen" : "paren.rparen";
        },
        nextState: "start"
      }, {
        token: "string.quasi.start",
        regex: /`/,
        push: [{
          token: "constant.language.escape",
          regex: i
        }, {
          token: "paren.quasi.start",
          regex: /\${/,
          push: "start"
        }, {
          token: "string.quasi.end",
          regex: /`/,
          next: "pop"
        }, {
          defaultToken: "string.quasi"
        }]
      }, {
        token: ["variable.parameter", "text"],
        regex: "(" + e + ")(\\s*)(?=\\=>)"
      }, {
        token: "paren.lparen",
        regex: "(\\()(?=.+\\s*=>)",
        next: "function_arguments"
      }, {
        token: "variable.language",
        regex: "(?:(?:(?:Weak)?(?:Set|Map))|Promise)\\b"
      }), this.$rules.function_arguments.unshift({
        token: "keyword.operator",
        regex: "=",
        next: "default_parameter"
      }, {
        token: "keyword.operator",
        regex: "\\.{3}"
      }), this.$rules.property.unshift({
        token: "support.function",
        regex: "(findIndex|repeat|startsWith|endsWith|includes|isSafeInteger|trunc|cbrt|log2|log10|sign|then|catch|finally|resolve|reject|race|any|all|allSettled|keys|entries|isInteger)\\b(?=\\()"
      }, {
        token: "constant.language",
        regex: "(?:MAX_SAFE_INTEGER|MIN_SAFE_INTEGER|EPSILON)\\b"
      }), (!a || a.jsx != !1) && l.call(this)), this.embedRules(p, "doc-", [p.getEndRule("no_regex")]), this.normalizeRules();
    };
    m.inherits(r, d);
    function l() {
      var a = e.replace("\\d", "\\d\\-"), n = {
        onMatch: function(i, t, c) {
          var g = i.charAt(1) == "/" ? 2 : 1;
          return g == 1 ? (t != this.nextState ? c.unshift(this.next, this.nextState, 0) : c.unshift(this.next), c[2]++) : g == 2 && t == this.nextState && (c[1]--, (!c[1] || c[1] < 0) && (c.shift(), c.shift())), [{
            type: "meta.tag.punctuation." + (g == 1 ? "" : "end-") + "tag-open.xml",
            value: i.slice(0, g)
          }, {
            type: "meta.tag.tag-name.xml",
            value: i.substr(g)
          }];
        },
        regex: "</?" + a,
        next: "jsxAttributes",
        nextState: "jsx"
      };
      this.$rules.start.unshift(n);
      var s = {
        regex: "{",
        token: "paren.quasi.start",
        push: "start"
      };
      this.$rules.jsx = [
        s,
        n,
        { include: "reference" },
        { defaultToken: "string" }
      ], this.$rules.jsxAttributes = [
        {
          token: "meta.tag.punctuation.tag-close.xml",
          regex: "/?>",
          onMatch: function(i, t, c) {
            return t == c[0] && c.shift(), i.length == 2 && (c[0] == this.nextState && c[1]--, (!c[1] || c[1] < 0) && c.splice(0, 2)), this.next = c[0] || "start", [{ type: this.token, value: i }];
          },
          nextState: "jsx"
        },
        s,
        o("jsxAttributes"),
        {
          token: "entity.other.attribute-name.xml",
          regex: a
        },
        {
          token: "keyword.operator.attribute-equals.xml",
          regex: "="
        },
        {
          token: "text.tag-whitespace.xml",
          regex: "\\s+"
        },
        {
          token: "string.attribute-value.xml",
          regex: "'",
          stateName: "jsx_attr_q",
          push: [
            { token: "string.attribute-value.xml", regex: "'", next: "pop" },
            { include: "reference" },
            { defaultToken: "string.attribute-value.xml" }
          ]
        },
        {
          token: "string.attribute-value.xml",
          regex: '"',
          stateName: "jsx_attr_qq",
          push: [
            { token: "string.attribute-value.xml", regex: '"', next: "pop" },
            { include: "reference" },
            { defaultToken: "string.attribute-value.xml" }
          ]
        },
        n
      ], this.$rules.reference = [{
        token: "constant.language.escape.reference.xml",
        regex: "(?:&#[0-9]+;)|(?:&#x[0-9a-fA-F]+;)|(?:&[a-zA-Z0-9_:\\.-]+;)"
      }];
    }
    function o(a) {
      return [
        {
          token: "comment",
          // multi line comment
          regex: /\/\*/,
          next: [
            p.getTagRule(),
            { token: "comment", regex: "\\*\\/", next: a || "pop" },
            { defaultToken: "comment", caseInsensitive: !0 }
          ]
        },
        {
          token: "comment",
          regex: "\\/\\/",
          next: [
            p.getTagRule(),
            { token: "comment", regex: "$|^", next: a || "pop" },
            { defaultToken: "comment", caseInsensitive: !0 }
          ]
        }
      ];
    }
    x.JavaScriptHighlightRules = r;
  }), ace.define("ace/mode/matching_brace_outdent", ["require", "exports", "module", "ace/range"], function(u, x, h) {
    var m = u("../range").Range, p = function() {
    };
    (function() {
      this.checkOutdent = function(d, e) {
        return /^\s+$/.test(d) ? /^\s*\}/.test(e) : !1;
      }, this.autoOutdent = function(d, e) {
        var r = d.getLine(e), l = r.match(/^(\s*\})/);
        if (!l)
          return 0;
        var o = l[1].length, a = d.findMatchingBracket({ row: e, column: o });
        if (!a || a.row == e)
          return 0;
        var n = this.$getIndent(d.getLine(a.row));
        d.replace(new m(e, 0, e, o - 1), n);
      }, this.$getIndent = function(d) {
        return d.match(/^\s*/)[0];
      };
    }).call(p.prototype), x.MatchingBraceOutdent = p;
  }), ace.define("ace/mode/folding/cstyle", ["require", "exports", "module", "ace/lib/oop", "ace/range", "ace/mode/folding/fold_mode"], function(u, x, h) {
    var m = u("../../lib/oop"), p = u("../../range").Range, d = u("./fold_mode").FoldMode, e = x.FoldMode = function(r) {
      r && (this.foldingStartMarker = new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/, "|" + r.start)), this.foldingStopMarker = new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/, "|" + r.end)));
    };
    m.inherits(e, d), (function() {
      this.foldingStartMarker = /([\{\[\(])[^\}\]\)]*$|^\s*(\/\*)/, this.foldingStopMarker = /^[^\[\{\(]*([\}\]\)])|^[\s\*]*(\*\/)/, this.singleLineBlockCommentRe = /^\s*(\/\*).*\*\/\s*$/, this.tripleStarBlockCommentRe = /^\s*(\/\*\*\*).*\*\/\s*$/, this.startRegionRe = /^\s*(\/\*|\/\/)#?region\b/, this._getFoldWidgetBase = this.getFoldWidget, this.getFoldWidget = function(r, l, o) {
        var a = r.getLine(o);
        if (this.singleLineBlockCommentRe.test(a) && !this.startRegionRe.test(a) && !this.tripleStarBlockCommentRe.test(a))
          return "";
        var n = this._getFoldWidgetBase(r, l, o);
        return !n && this.startRegionRe.test(a) ? "start" : n;
      }, this.getFoldWidgetRange = function(r, l, o, a) {
        var n = r.getLine(o);
        if (this.startRegionRe.test(n))
          return this.getCommentRegionBlock(r, n, o);
        var t = n.match(this.foldingStartMarker);
        if (t) {
          var s = t.index;
          if (t[1])
            return this.openingBracketBlock(r, t[1], o, s);
          var i = r.getCommentFoldRange(o, s + t[0].length, 1);
          return i && !i.isMultiLine() && (a ? i = this.getSectionRange(r, o) : l != "all" && (i = null)), i;
        }
        if (l !== "markbegin") {
          var t = n.match(this.foldingStopMarker);
          if (t) {
            var s = t.index + t[0].length;
            return t[1] ? this.closingBracketBlock(r, t[1], o, s) : r.getCommentFoldRange(o, s, -1);
          }
        }
      }, this.getSectionRange = function(r, l) {
        var o = r.getLine(l), a = o.search(/\S/), n = l, s = o.length;
        l = l + 1;
        for (var i = l, t = r.getLength(); ++l < t; ) {
          o = r.getLine(l);
          var c = o.search(/\S/);
          if (c !== -1) {
            if (a > c)
              break;
            var g = this.getFoldWidgetRange(r, "all", l);
            if (g) {
              if (g.start.row <= n)
                break;
              if (g.isMultiLine())
                l = g.end.row;
              else if (a == c)
                break;
            }
            i = l;
          }
        }
        return new p(n, s, i, r.getLine(i).length);
      }, this.getCommentRegionBlock = function(r, l, o) {
        for (var a = l.search(/\s*$/), n = r.getLength(), s = o, i = /^\s*(?:\/\*|\/\/|--)#?(end)?region\b/, t = 1; ++o < n; ) {
          l = r.getLine(o);
          var c = i.exec(l);
          if (c && (c[1] ? t-- : t++, !t))
            break;
        }
        var g = o;
        if (g > s)
          return new p(s, a, g, l.length);
      };
    }).call(e.prototype);
  }), ace.define("ace/mode/javascript", ["require", "exports", "module", "ace/lib/oop", "ace/mode/text", "ace/mode/javascript_highlight_rules", "ace/mode/matching_brace_outdent", "ace/worker/worker_client", "ace/mode/behaviour/cstyle", "ace/mode/folding/cstyle"], function(u, x, h) {
    var m = u("../lib/oop"), p = u("./text").Mode, d = u("./javascript_highlight_rules").JavaScriptHighlightRules, e = u("./matching_brace_outdent").MatchingBraceOutdent, r = u("../worker/worker_client").WorkerClient, l = u("./behaviour/cstyle").CstyleBehaviour, o = u("./folding/cstyle").FoldMode, a = function() {
      this.HighlightRules = d, this.$outdent = new e(), this.$behaviour = new l(), this.foldingRules = new o();
    };
    m.inherits(a, p), (function() {
      this.lineCommentStart = "//", this.blockComment = { start: "/*", end: "*/" }, this.$quotes = { '"': '"', "'": "'", "`": "`" }, this.$pairQuotesAfter = {
        "`": /\w/
      }, this.getNextLineIndent = function(n, s, i) {
        var t = this.$getIndent(s), c = this.getTokenizer().getLineTokens(s, n), g = c.tokens, y = c.state;
        if (g.length && g[g.length - 1].type == "comment")
          return t;
        if (n == "start" || n == "no_regex") {
          var f = s.match(/^.*(?:\bcase\b.*:|[\{\(\[])\s*$/);
          f && (t += i);
        } else if (n == "doc-start") {
          if (y == "start" || y == "no_regex")
            return "";
          var f = s.match(/^\s*(\/?)\*/);
          f && (f[1] && (t += " "), t += "* ");
        }
        return t;
      }, this.checkOutdent = function(n, s, i) {
        return this.$outdent.checkOutdent(s, i);
      }, this.autoOutdent = function(n, s, i) {
        this.$outdent.autoOutdent(s, i);
      }, this.createWorker = function(n) {
        var s = new r(["ace"], "ace/mode/javascript_worker", "JavaScriptWorker");
        return s.attachToDocument(n.getDocument()), s.on("annotate", function(i) {
          n.setAnnotations(i.data);
        }), s.on("terminate", function() {
          n.clearAnnotations();
        }), s;
      }, this.$id = "ace/mode/javascript", this.snippetFileId = "ace/snippets/javascript";
    }).call(a.prototype), x.Mode = a;
  }), function() {
    ace.require(["ace/mode/javascript"], function(u) {
      k && (k.exports = u);
    });
  }();
})(v);
