import { __module as R } from "../../../_virtual/mode-yaml.ts";
(function(_, W) {
  ace.define("ace/mode/yaml_highlight_rules", ["require", "exports", "module", "ace/lib/oop", "ace/mode/text_highlight_rules"], function(o, f, x) {
    var m = o("../lib/oop"), u = o("./text_highlight_rules").TextHighlightRules, g = function() {
      this.$rules = {
        start: [
          {
            token: "comment",
            regex: "#.*$"
          },
          {
            token: "list.markup",
            regex: /^(?:-{3}|\.{3})\s*(?=#|$)/
          },
          {
            token: "list.markup",
            regex: /^\s*[\-?](?:$|\s)/
          },
          {
            token: "constant",
            regex: "!![\\w//]+"
          },
          {
            token: "constant.language",
            regex: "[&\\*][a-zA-Z0-9-_]+"
          },
          {
            token: ["meta.tag", "keyword"],
            regex: /^(\s*\w[^\s:]*?)(:(?=\s|$))/
          },
          {
            token: ["meta.tag", "keyword"],
            regex: /(\w[^\s:]*?)(\s*:(?=\s|$))/
          },
          {
            token: "keyword.operator",
            regex: "<<\\w*:\\w*"
          },
          {
            token: "keyword.operator",
            regex: "-\\s*(?=[{])"
          },
          {
            token: "string",
            // single line
            regex: '["](?:(?:\\\\.)|(?:[^"\\\\]))*?["]'
          },
          {
            token: "string",
            // multi line string start
            regex: /[|>][-+\d]*(?:$|\s+(?:$|#))/,
            onMatch: function(l, n, a, e) {
              e = e.replace(/ #.*/, "");
              var r = /^ *((:\s*)?-(\s*[^|>])?)?/.exec(e)[0].replace(/\S\s*$/, "").length, t = parseInt(/\d+[\s+-]*$/.exec(e));
              return t ? (r += t - 1, this.next = "mlString") : this.next = "mlStringPre", a.length ? (a[0] = this.next, a[1] = r) : (a.push(this.next), a.push(r)), this.token;
            },
            next: "mlString"
          },
          {
            token: "string",
            // single quoted string
            regex: "['](?:(?:\\\\.)|(?:[^'\\\\]))*?[']"
          },
          {
            token: "constant.numeric",
            // float
            regex: /(\b|[+\-\.])[\d_]+(?:(?:\.[\d_]*)?(?:[eE][+\-]?[\d_]+)?)(?=[^\d-\w]|$)$/
          },
          {
            token: "constant.numeric",
            // other number
            regex: /[+\-]?\.inf\b|NaN\b|0x[\dA-Fa-f_]+|0b[10_]+/
          },
          {
            token: "constant.language.boolean",
            regex: "\\b(?:true|false|TRUE|FALSE|True|False|yes|no)\\b"
          },
          {
            token: "paren.lparen",
            regex: "[[({]"
          },
          {
            token: "paren.rparen",
            regex: "[\\])}]"
          },
          {
            token: "text",
            regex: /[^\s,:\[\]\{\}]+/
          }
        ],
        mlStringPre: [
          {
            token: "indent",
            regex: /^ *$/
          },
          {
            token: "indent",
            regex: /^ */,
            onMatch: function(l, n, a) {
              var e = a[1];
              return e >= l.length ? (this.next = "start", a.shift(), a.shift()) : (a[1] = l.length - 1, this.next = a[0] = "mlString"), this.token;
            },
            next: "mlString"
          },
          {
            defaultToken: "string"
          }
        ],
        mlString: [
          {
            token: "indent",
            regex: /^ *$/
          },
          {
            token: "indent",
            regex: /^ */,
            onMatch: function(l, n, a) {
              var e = a[1];
              return e >= l.length ? (this.next = "start", a.splice(0)) : this.next = "mlString", this.token;
            },
            next: "mlString"
          },
          {
            token: "string",
            regex: ".+"
          }
        ]
      }, this.normalizeRules();
    };
    m.inherits(g, u), f.YamlHighlightRules = g;
  }), ace.define("ace/mode/matching_brace_outdent", ["require", "exports", "module", "ace/range"], function(o, f, x) {
    var m = o("../range").Range, u = function() {
    };
    (function() {
      this.checkOutdent = function(g, l) {
        return /^\s+$/.test(g) ? /^\s*\}/.test(l) : !1;
      }, this.autoOutdent = function(g, l) {
        var n = g.getLine(l), a = n.match(/^(\s*\})/);
        if (!a)
          return 0;
        var e = a[1].length, r = g.findMatchingBracket({ row: l, column: e });
        if (!r || r.row == l)
          return 0;
        var t = this.$getIndent(g.getLine(r.row));
        g.replace(new m(l, 0, l, e - 1), t);
      }, this.$getIndent = function(g) {
        return g.match(/^\s*/)[0];
      };
    }).call(u.prototype), f.MatchingBraceOutdent = u;
  }), ace.define("ace/mode/folding/coffee", ["require", "exports", "module", "ace/lib/oop", "ace/mode/folding/fold_mode", "ace/range"], function(o, f, x) {
    var m = o("../../lib/oop"), u = o("./fold_mode").FoldMode, g = o("../../range").Range, l = f.FoldMode = function() {
    };
    m.inherits(l, u), (function() {
      this.commentBlock = function(n, a) {
        var e = /\S/, r = n.getLine(a), t = r.search(e);
        if (!(t == -1 || r[t] != "#")) {
          for (var d = r.length, h = n.getLength(), i = a, c = a; ++a < h; ) {
            r = n.getLine(a);
            var s = r.search(e);
            if (s != -1) {
              if (r[s] != "#")
                break;
              c = a;
            }
          }
          if (c > i) {
            var p = n.getLine(c).length;
            return new g(i, d, c, p);
          }
        }
      }, this.getFoldWidgetRange = function(n, a, e) {
        var r = this.indentationBlock(n, e);
        if (r || (r = this.commentBlock(n, e), r))
          return r;
      }, this.getFoldWidget = function(n, a, e) {
        var r = n.getLine(e), t = r.search(/\S/), d = n.getLine(e + 1), h = n.getLine(e - 1), i = h.search(/\S/), c = d.search(/\S/);
        if (t == -1)
          return n.foldWidgets[e - 1] = i != -1 && i < c ? "start" : "", "";
        if (i == -1) {
          if (t == c && r[t] == "#" && d[t] == "#")
            return n.foldWidgets[e - 1] = "", n.foldWidgets[e + 1] = "", "start";
        } else if (i == t && r[t] == "#" && h[t] == "#" && n.getLine(e - 2).search(/\S/) == -1)
          return n.foldWidgets[e - 1] = "start", n.foldWidgets[e + 1] = "", "";
        return i != -1 && i < t ? n.foldWidgets[e - 1] = "start" : n.foldWidgets[e - 1] = "", t < c ? "start" : "";
      };
    }).call(l.prototype);
  }), ace.define("ace/mode/folding/yaml", ["require", "exports", "module", "ace/lib/oop", "ace/mode/folding/coffee", "ace/range"], function(o, f, x) {
    var m = o("../../lib/oop"), u = o("./coffee").FoldMode, g = o("../../range").Range, l = f.FoldMode = function() {
    };
    m.inherits(l, u), (function() {
      this.getFoldWidgetRange = function(n, a, e) {
        var r = /\S/, t = n.getLine(e), d = t.search(r), h = t[d] === "#", i = t[d] === "-";
        if (d != -1) {
          var c = t.length, s = n.getLength(), p = e, k = e;
          if (h) {
            var v = this.commentBlock(n, e);
            if (v)
              return v;
          } else if (i) {
            var v = this.indentationBlock(n, e);
            if (v)
              return v;
          } else
            for (; ++e < s; ) {
              var t = n.getLine(e), S = t.search(r);
              if (S != -1) {
                if (S <= d && t[d] !== "-") {
                  var $ = n.getTokenAt(e, 0);
                  if (!$ || $.type !== "string")
                    break;
                }
                k = e;
              }
            }
          if (k > p) {
            var y = n.getLine(k).length;
            return new g(p, c, k, y);
          }
        }
      }, this.getFoldWidget = function(n, a, e) {
        var r = n.getLine(e), t = r.search(/\S/), d = n.getLine(e + 1), h = n.getLine(e - 1), i = h.search(/\S/), c = d.search(/\S/), s = r[t] === "-";
        if (t == -1)
          return n.foldWidgets[e - 1] = i != -1 && i < c ? "start" : "", "";
        if (i == -1) {
          if (t == c && r[t] == "#" && d[t] == "#")
            return n.foldWidgets[e - 1] = "", n.foldWidgets[e + 1] = "", "start";
        } else if (i == t && r[t] == "#" && h[t] == "#" && n.getLine(e - 2).search(/\S/) == -1)
          return n.foldWidgets[e - 1] = "start", n.foldWidgets[e + 1] = "", "";
        return i != -1 && i < t || i != -1 && i == t && s ? n.foldWidgets[e - 1] = "start" : n.foldWidgets[e - 1] = "", t < c ? "start" : "";
      };
    }).call(l.prototype);
  }), ace.define("ace/mode/yaml", ["require", "exports", "module", "ace/lib/oop", "ace/mode/text", "ace/mode/yaml_highlight_rules", "ace/mode/matching_brace_outdent", "ace/mode/folding/yaml", "ace/worker/worker_client"], function(o, f, x) {
    var m = o("../lib/oop"), u = o("./text").Mode, g = o("./yaml_highlight_rules").YamlHighlightRules, l = o("./matching_brace_outdent").MatchingBraceOutdent, n = o("./folding/yaml").FoldMode, a = o("../worker/worker_client").WorkerClient, e = function() {
      this.HighlightRules = g, this.$outdent = new l(), this.foldingRules = new n(), this.$behaviour = this.$defaultBehaviour;
    };
    m.inherits(e, u), (function() {
      this.lineCommentStart = ["#"], this.getNextLineIndent = function(r, t, d) {
        var h = this.$getIndent(t);
        if (r == "start") {
          var i = t.match(/^.*[\{\(\[]\s*$/);
          i && (h += d);
        }
        return h;
      }, this.checkOutdent = function(r, t, d) {
        return this.$outdent.checkOutdent(t, d);
      }, this.autoOutdent = function(r, t, d) {
        this.$outdent.autoOutdent(t, d);
      }, this.createWorker = function(r) {
        var t = new a(["ace"], "ace/mode/yaml_worker", "YamlWorker");
        return t.attachToDocument(r.getDocument()), t.on("annotate", function(d) {
          r.setAnnotations(d.data);
        }), t.on("terminate", function() {
          r.clearAnnotations();
        }), t;
      }, this.$id = "ace/mode/yaml";
    }).call(e.prototype), f.Mode = e;
  }), function() {
    ace.require(["ace/mode/yaml"], function(o) {
      _ && (_.exports = o);
    });
  }();
})(R);
