import d from "../utils.ts";
import R from "../helpers/buildURL.ts";
import b from "./InterceptorManager.ts";
import S from "./dispatchRequest.ts";
import f from "./mergeConfig.ts";
import C from "./buildFullPath.ts";
import k from "../helpers/validator.ts";
import I from "./AxiosHeaders.ts";
const u = k.validators;
class m {
  constructor(t) {
    this.defaults = t, this.interceptors = {
      request: new b(),
      response: new b()
    };
  }
  /**
   * Dispatch a request
   *
   * @param {String|Object} configOrUrl The config specific for this request (merged with this.defaults)
   * @param {?Object} config
   *
   * @returns {Promise} The Promise to be fulfilled
   */
  async request(t, e) {
    try {
      return await this._request(t, e);
    } catch (s) {
      if (s instanceof Error) {
        let n;
        Error.captureStackTrace ? Error.captureStackTrace(n = {}) : n = new Error();
        const a = n.stack ? n.stack.replace(/^.+\n/, "") : "";
        s.stack ? a && !String(s.stack).endsWith(a.replace(/^.+\n.+\n/, "")) && (s.stack += `
` + a) : s.stack = a;
      }
      throw s;
    }
  }
  _request(t, e) {
    typeof t == "string" ? (e = e || {}, e.url = t) : e = t || {}, e = f(this.defaults, e);
    const { transitional: s, paramsSerializer: n, headers: a } = e;
    s !== void 0 && k.assertOptions(s, {
      silentJSONParsing: u.transitional(u.boolean),
      forcedJSONParsing: u.transitional(u.boolean),
      clarifyTimeoutError: u.transitional(u.boolean)
    }, !1), n != null && (d.isFunction(n) ? e.paramsSerializer = {
      serialize: n
    } : k.assertOptions(n, {
      encode: u.function,
      serialize: u.function
    }, !0)), e.method = (e.method || this.defaults.method || "get").toLowerCase();
    let y = a && d.merge(
      a.common,
      a[e.method]
    );
    a && d.forEach(
      ["delete", "get", "head", "post", "put", "patch", "common"],
      (r) => {
        delete a[r];
      }
    ), e.headers = I.concat(y, a);
    const h = [];
    let E = !0;
    this.interceptors.request.forEach(function(i) {
      typeof i.runWhen == "function" && i.runWhen(e) === !1 || (E = E && i.synchronous, h.unshift(i.fulfilled, i.rejected));
    });
    const p = [];
    this.interceptors.response.forEach(function(i) {
      p.push(i.fulfilled, i.rejected);
    });
    let l, o = 0, c;
    if (!E) {
      const r = [S.bind(this), void 0];
      for (r.unshift.apply(r, h), r.push.apply(r, p), c = r.length, l = Promise.resolve(e); o < c; )
        l = l.then(r[o++], r[o++]);
      return l;
    }
    c = h.length;
    let q = e;
    for (o = 0; o < c; ) {
      const r = h[o++], i = h[o++];
      try {
        q = r(q);
      } catch (P) {
        i.call(this, P);
        break;
      }
    }
    try {
      l = S.call(this, q);
    } catch (r) {
      return Promise.reject(r);
    }
    for (o = 0, c = p.length; o < c; )
      l = l.then(p[o++], p[o++]);
    return l;
  }
  getUri(t) {
    t = f(this.defaults, t);
    const e = C(t.baseURL, t.url);
    return R(e, t.params, t.paramsSerializer);
  }
}
d.forEach(["delete", "get", "head", "options"], function(t) {
  m.prototype[t] = function(e, s) {
    return this.request(f(s || {}, {
      method: t,
      url: e,
      data: (s || {}).data
    }));
  };
});
d.forEach(["post", "put", "patch"], function(t) {
  function e(s) {
    return function(a, y, h) {
      return this.request(f(h || {}, {
        method: t,
        headers: s ? {
          "Content-Type": "multipart/form-data"
        } : {},
        url: a,
        data: y
      }));
    };
  }
  m.prototype[t] = e(), m.prototype[t + "Form"] = e(!0);
});
const A = m;
export {
  A as default
};
