import { commonjsGlobal as g, getDefaultExportFromCjs as B } from "../../_virtual/_commonjsHelpers.ts";
import { __module as i } from "../../_virtual/enc-base64.ts";
import { __require as A } from "./core.ts";
(function(m, b) {
  (function(c, f) {
    m.exports = f(A());
  })(g, function(c) {
    return function() {
      var f = c, l = f.lib, d = l.WordArray, x = f.enc;
      x.Base64 = {
        /**
         * Converts a word array to a Base64 string.
         *
         * @param {WordArray} wordArray The word array.
         *
         * @return {string} The Base64 string.
         *
         * @static
         *
         * @example
         *
         *     var base64String = CryptoJS.enc.Base64.stringify(wordArray);
         */
        stringify: function(e) {
          var s = e.words, o = e.sigBytes, t = this._map;
          e.clamp();
          for (var a = [], r = 0; r < o; r += 3)
            for (var n = s[r >>> 2] >>> 24 - r % 4 * 8 & 255, p = s[r + 1 >>> 2] >>> 24 - (r + 1) % 4 * 8 & 255, h = s[r + 2 >>> 2] >>> 24 - (r + 2) % 4 * 8 & 255, _ = n << 16 | p << 8 | h, v = 0; v < 4 && r + v * 0.75 < o; v++)
              a.push(t.charAt(_ >>> 6 * (3 - v) & 63));
          var u = t.charAt(64);
          if (u)
            for (; a.length % 4; )
              a.push(u);
          return a.join("");
        },
        /**
         * Converts a Base64 string to a word array.
         *
         * @param {string} base64Str The Base64 string.
         *
         * @return {WordArray} The word array.
         *
         * @static
         *
         * @example
         *
         *     var wordArray = CryptoJS.enc.Base64.parse(base64String);
         */
        parse: function(e) {
          var s = e.length, o = this._map, t = this._reverseMap;
          if (!t) {
            t = this._reverseMap = [];
            for (var a = 0; a < o.length; a++)
              t[o.charCodeAt(a)] = a;
          }
          var r = o.charAt(64);
          if (r) {
            var n = e.indexOf(r);
            n !== -1 && (s = n);
          }
          return C(e, s, t);
        },
        _map: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="
      };
      function C(e, s, o) {
        for (var t = [], a = 0, r = 0; r < s; r++)
          if (r % 4) {
            var n = o[e.charCodeAt(r - 1)] << r % 4 * 2, p = o[e.charCodeAt(r)] >>> 6 - r % 4 * 2, h = n | p;
            t[a >>> 2] |= h << 24 - a % 4 * 8, a++;
          }
        return d.create(t, a);
      }
    }(), c.enc.Base64;
  });
})(i);
var y = i.exports;
const L = /* @__PURE__ */ B(y);
export {
  L as default
};
